<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="文件名" prop="deptId">
        <el-input v-model="queryParams.deptId" placeholder="文件名" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="info" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Upload" @click="handleAdd" v-hasPermi="['business:workpiece:list']">上传</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate" v-hasPermi="['business:workpiece:list']">编辑</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['business:workpiece:list']"
          >删除</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['business:workpiece:list']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="fileList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="40" align="center" />
      <el-table-column label="公司名称" align="center" prop="companyName" />
      <el-table-column label="文件名" align="center" prop="name" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center">
        <template #default="scope">
          <el-button link type="primary" icon="Download" @click="handleDownLoad(scope.row.url)" v-hasPermi="['business:workpiece:list']"
            >下载</el-button
          >
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['business:workpiece:list']">编辑</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['business:workpiece:list']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改文件库对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body draggable>
      <el-form ref="fileRef" :model="form" :rules="rules" label-width="120px">
        <!--
        <el-form-item label="归属部门：" prop="deptId">
          <el-tree-select v-model="form.deptId" :data="deptOptions" :props="{ value: 'id', label: 'label', children: 'children' }" value-key="id" placeholder="请选择归属部门" check-strictly :render-after-expand="false" />
        </el-form-item>
        -->
        <el-form-item label="文件名：" prop="name">
          <el-input v-model="form.name" placeholder="请输入名称" style="width: 214px" />
        </el-form-item>
        <el-form-item label="备注：" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" style="width: 214px" />
        </el-form-item>
        <el-form-item label="上传按钮：">
          <el-upload action="#" :http-request="upload" :with-credentials="true" :show-file-list="false" multiple>
            <el-button type="primary" icon="Upload">点击上传</el-button>
          </el-upload>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="File">
import { listFile, getFile, delFile, addFile, updateFile, uploadFile } from '@/api/tool/file'
import { deptTreeSelect } from '@/api/system/user'
import { ref } from '@vue/reactivity'
import useUserStore from '@/store/modules/user'
const route = useRoute()
const { proxy } = getCurrentInstance()
const companyId = useUserStore().user.companyId
const fileList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref('')
const deptOptions = ref(undefined)
const deptId = ref(0)
const masterId = ref(0)
const masterTableName = ref('')
const webHost = import.meta.env.VITE_APP_BASE_API

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10
  },
  rules: {
    deptId: [{ required: true, message: '部门不能为空', trigger: 'blur' }],
    masterTableName: [{ required: true, message: '所属表名不能为空', trigger: 'blur' }],
    masterId: [{ required: true, message: '关联表id不能为空', trigger: 'blur' }],
    name: [{ required: true, message: '名称不能为空', trigger: 'blur' }]
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 文件下载 */
function handleDownLoad(url) {
  window.open(webHost + '/' + url)
}

/** 文件上传 */
function upload(param) {
  const formData = new FormData()
  formData.append('file', param.file)
  uploadFile(formData).then((res) => {
    if (res.code === 200) {
      form.value.name = res.data.name
      form.value.url = res.data.url
      form.value.deptId = deptId.value
      form.value.masterId = masterId.value
      form.value.masterTableName = masterTableName.value
    }
  })
}

/** 查询部门下拉树结构 */
function getDeptTree() {
  deptTreeSelect().then((response) => {
    deptOptions.value = response.data
  })
}

/** 查询文件库列表 */
function getList() {
  loading.value = true
  queryParams.value.masterId = route.params.masterId
  queryParams.value.masterTableName = route.params.masterTableName
  listFile(queryParams.value).then((response) => {
    fileList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {}
  proxy.resetForm('fileRef')
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm('queryRef')
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  form.value.deptId = deptId.value
  title.value = '添加文件库'
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getFile(_id).then((response) => {
    form.value = response.data
    open.value = true
    title.value = '修改文件库'
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs['fileRef'].validate((valid) => {
    if (valid) {
      if (form.value.id != null) {
        updateFile(form.value).then((response) => {
          proxy.$modal.msgSuccess('修改成功')
          open.value = false
          getList()
        })
      } else {
        addFile(form.value).then((response) => {
          proxy.$modal.msgSuccess('新增成功')
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal
    .confirm('是否确认删除？')
    .then(function () {
      return delFile(_ids)
    })
    .then(() => {
      getList()
      proxy.$modal.msgSuccess('删除成功')
    })
    .catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download(
    'tool/file/export',
    {
      ...queryParams.value
    },
    `file_${new Date().getTime()}.xlsx`
  )
}
deptId.value = route.params.deptId
masterId.value = route.params.masterId
masterTableName.value = route.params.masterTableName
getDeptTree()
getList()
</script>
